#define DOCTEST_CONFIG_NO_MULTITHREADING
#define DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN
#include "doctest.h"
#include "histogram_internal.h"

TEST_CASE("distinct positive numbers") {
    double min = 0;
    double max = 0;
    find_minmax({1, 2}, min, max);
    CHECK(min == 1);
    CHECK(max == 2);
}

TEST_CASE("find_minmax with one negative element") {
    std::vector<double> numbers{-42};
    double min, max;
    find_minmax(numbers, min, max);
    CHECK(min == -42);
    CHECK(max == -42);
}

TEST_CASE("find_minmax with decimal values") {
    std::vector<double> numbers{1.1, 2.2, 3.3, 0.5};
    double min, max;
    find_minmax(numbers, min, max);
    CHECK(min == 0.5);
    CHECK(max == 3.3);
}

TEST_CASE("find_minmax with identical zeros") {
    std::vector<double> numbers{0, 0, 0, 0};
    double min, max;
    find_minmax(numbers, min, max);
    CHECK(min == 0);
    CHECK(max == 0);
}
